package vishnu.testvis.dendro;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import vishnu.testvis.visual.*;
import vishnu.testvis.object.*;
import java.util.*;
import vishnu.testvis.treemap.table.*;

class DendroKeywordPanel extends JPanel
{
    RW_DataModel _dataModel;
    JTable _table = new JTable();
    JScrollPane theScrollPane;
    JCheckBox checkBoxes[];
    JLabel labels[];
    Vishnu currentMain;
    DendroPanel parentPane;

    public DendroKeywordPanel(Vishnu currentMain, DendroPanel parent)
    {
        this.currentMain = currentMain;
        this.parentPane = parent;
        
        theScrollPane = new JScrollPane();

        setPreferredSize(new Dimension(200,900));
        setBorder(BorderFactory.createLoweredBevelBorder());
        setLayout(new BorderLayout(10,0));
        Font theFont = new java.awt.Font("Monospaced", 0, 12);

         _dataModel = new RW_DataModel();
         _table.setModel(_dataModel);

        _table.setAutoCreateColumnsFromModel(false);
        _table.getColumnModel().getColumn(0).setPreferredWidth(20);
        _table.getColumnModel().getColumn(1).setPreferredWidth(100);
        _table.getColumnModel().getColumn(2).setPreferredWidth(50);
        _table.setRowSelectionAllowed(false);
        setupRenderer();

        theScrollPane.getViewport().add(_table, null);
        add(theScrollPane,"Center");

        setVisible(true);

        JButton refineButton = new JButton("Filter Documents");
        refineButton.setBorder(BorderFactory.createRaisedBevelBorder());
        refineButton.setMaximumSize(new Dimension(30,70));

        MouseListener ml = new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                 refineEngine();
            }
        };

        refineButton.addMouseListener(ml);
        refineButton.setFont(theFont);
        add(refineButton,"South");
    }

    public void refineEngine()
    {
        // the filter words are available from within _dataModel, so nothing
       // is passed on
       parentPane.hLinkPanel.setText(_dataModel.getRefinedDocs());
       String trec_id[] = _dataModel.getRefinedTrecIDs();
       String filter_Words[] = _dataModel.getFilterWords();
       String s = new String("");
       for( int i = 0; i < filter_Words.length; i++ )
       {
            s += filter_Words[i] + " ";
       }
    }
        

    public void update(vishnu.testvis.dendro.ClusterObj c)
    {
        _dataModel.setData(currentMain.dataManager.getWords(), c);
    }

    public void clear()
    {
        _dataModel.clear();
    }
    private void setupRenderer()
    {
        BarRenderer bar = new BarRenderer();
        //-- Have a number painted in the middle of the bar
        bar.setStringPainted(true);
        //-- setup the background color of the bar
        bar.setBackground(_table.getBackground());

        //-- render the last column as a bar
        _table.getColumnModel().getColumn(2).setCellRenderer(bar);
    }


}
